#include "testlib.h"

#include <vector>
using namespace std;

const int maxn = 150 + 5, maxm = 400 + 10;

int n, m;
int g[maxn][maxm];
bool vis[maxn];
int match[maxn];

bool mark[maxm];

int mdfs(int u) {
	if(u == -1) return 1;
	for(int v = 0; v < n; v++) if(g[v][u] && !vis[v]) {
		vis[v] = true;
		if(mdfs(match[v])) {
			match[v] = u;
			return 1;
		}
	}
	return 0;
}

int main(int argc, char* argv[]) {
	registerChecker("network", argc, argv);

	n = inf.readInt();
	m = inf.readInt();
	for(int i = 0; i < n; i++)
		for(int j = 0; j < m; j++)
			g[i][j] = inf.readInt(0, 1);

	int jval = ans.readInt();
	int pval = ouf.readInt(0, 1);

	if(jval != pval)
		quitf(_wa, "expected %d, found %d", jval, pval);

	if(pval == 1)
		quit(_ok);

	vector<int> arr = ouf.readInts(n, 1, m);
	for(int &u: arr) u--;

	memset(mark, false, sizeof mark);
	for(int u: arr) {
		if(mark[u])
			quitf(_wa, "expected %d distinct ints, but found duplicates", n);
		mark[u] = true;
	}

	ouf.skipBlanks();
	ouf.readEof();

	memset(match, -1, sizeof match);
	int msize = 0;
	for(int u = 0; u < m; u++) if(mark[u]) {
		memset(vis, false, sizeof vis);
		msize += mdfs(u);
	}

	if(msize == n)
		quitf(_wa, "the given set has a perfect matching, which is wrong");

	quit(_ok);
}
